package cokr.xit.fims.sndb.service;

import java.util.List;

import cokr.xit.fims.sndb.SndbQuery;
import cokr.xit.fims.sndb.Svbtc;
import cokr.xit.foundation.data.DataObject;

/**공시송달 대장 관리 서비스 인터페이스.
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2024-01-09	JoJH 최초 작성
 * ================================
 * </pre>
 */
public interface SvbtcService {

	/**지정한 조건에 따라 공시송달 대장 목록을 조회하여 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 목록
	 */
	List<DataObject> getSvbtcList(SndbQuery req);

	/**지정한 조건에 따라 공시송달 대장 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	List<DataObject> getSvbtcs(SndbQuery req);

	/**지정한 조건에 따라 공시송달 대장 객체의 마지막 1개를 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	DataObject getSvbtcInfo(SndbQuery req);

	/**지정한 조건에 따라 공시송달 상세 목록을 조회하여 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 목록
	 */
	List<DataObject> getSvbtcDtlList(SndbQuery req);

	/**지정한 조건에 따라 공시송달 상세 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	List<DataObject> getSvbtcDtls(SndbQuery req);

	/**공시송달 대장 정보를 등록한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String createSvbtc(SndbQuery req, Svbtc svbtc);

	/**공시송달 대장 정보를 수정한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String updateSvbtc(Svbtc svbtc);

	/**공시송달 대장 정보를 삭제한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String removeSvbtc(Svbtc svbtc);

	/**공시송달 정보를 삭제한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String removeSvbtcEach(Svbtc svbtc);

}
